# README

This directory contains all the code for **3DTAB (3D Transfer Attack Benchmark)**.  
**Note:** To comply with double-blind review requirements, we have removed certain files containing server-specific paths. As a result, this version may not work out of the box and is intended for reference only.  

---

## Setting Up the Environment

To run 3DTAB, you need to set up a specific environment. You can easily create the required environment by executing the provided `install.sh` script in this folder.  
- The default environment name is the same as this folder's name.  
- Ensure you have installed the required package manager (e.g., Conda).  

---

## Running the Experiments  

The experiments described in the paper are organized as bash scripts named `run_exp_*.sh`.  
- Each script corresponds to a specific experiment.  
- Detailed mappings between these scripts and the experiments are documented in the `README.md` file located in the respective subfolders.  

---

## Additional Notes  

For any issues related to environment setup or experiment scripts, please refer to the comments in the code or contact us after the review process.  
